package com.laguerre.kan;

public class BaseObject {
	private static int availableId = Integer.MIN_VALUE;

	private static int grabAvailableId() {
		int id = availableId;
		++availableId;
		return id;
	}

	private int id;
	private String name;

	public BaseObject() {
		this.id = grabAvailableId();
		setName(null);
	}

	protected final void copyBaseObjectContent(BaseObject orig) {
		this.name = orig.name;
	}

	public final int getId() {
		return this.id;
	}

	public final void setName(String name) {
		if (name == null || name.length() == 0) {
			this.name = "id: " + getId();
		} else {
			this.name = name;
		}
	}

	public final String getName() {
		return this.name;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj) {
			return true;
		} else if (!(obj instanceof BaseObject)) {
			return false;
		} else {
			BaseObject bo = (BaseObject) obj;
			return this.id == bo.id;
		}
	}

	@Override
	public int hashCode() {
		return this.id;
	}
}
